/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 *********************************************************************/

#ifdef USE_NETWORK

#ifndef CLASS_NETWORK_GNET_SERVER_HEADER
#define CLASS_NETWORK_GNET_SERVER_HEADER

#include <gnet.h>
#include "../server.h"

namespace Network {
  namespace GNet {

    class Server : public Network::Server {
      public:
	static void async_accept_connection(GTcpSocket* server_socket,
					    GTcpSocket* client_socket,
					    gpointer server_ptr);
      public:
	// constructor
	Server();
	// destructor
	~Server();

	// the names of the addresses of this server
	vector<string> local_addresses() const;

	// start the server
	void start();
	// stop the server
	void stop();

	// check for data on the connections
	void update();

      private: // gnet part

	// local internet address
	GInetAddr* gnet_local_addr;
	// server
	GTcpSocket* gnet_server;
    }; // class Server : public Network::Server

  } // namespace GNet

} // namespace Network

#endif // #ifndef CLASS_NETWORK_GNET_SERVER_HEADE

#endif // #ifdef USE_NETWORK
